
// TODO: Can we remove hard dependency on immutable?

// import * as FS from './fantasy-land'
import { ap } from './fantasy-land'
import { Iterable } from 'immutable'

import type { Apply, Functor } from './fantasy-land'

export type Traversable<V> = V[]
// export type Traversable<V> = FS.Traversable<V> | V[]
  // FS.Traversable<V> | V[] | Map<any,V> | Set<any,V> | Iterable<any,V>

export {
  sequence,
  traverse,
}

// var { ap } = FS

function sequence<A, FA: Apply<Traversable<A>>>(
  pure: <T, FT: Apply<T>>(_: T) => FT,
  t: Traversable<Apply<A>>
): FA {
  if (typeof t.sequence !== 'undefined') {
    return t.sequence(pure)
  }
  else if (t instanceof Array) { return sequenceArray(pure, t) }
  // else if (t instanceof Map) {}
  // else if (t instanceof Set) {}
  // else if (t instanceof Iterable) {}
  else {
    throw new TypeError('No implementation of Traversable for '+ String(t))
  }
}

function traverse<A,B, FTB: Apply<Traversable<B>>>(
  pure: <T, FT: Apply<T>>(_: T) => FT,
  f: <FB: Apply<B>>(_: A) => FB,
  t: Traversable<A>
): FTB {
  return sequence(pure, t.map(f))
}

function sequenceArray<A, FA: Apply<A[]>>(
  pure: <T, FT: Apply<T>>(_: T) => FT,
  t: Apply<A>[]
): FA {
  var append = pure(ys => x => ys.concat(x))
  return t.reduce((ys, x) => ap(ap(append, pure(ys)), x), pure([]))
}
